﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
'**********************************************************************************************************
'B4J example for using the B4JVlcj-wrapper
'The B4JVlcj-wrapper requires 3 additional jars(libraries). See the official thread in the B4X-forum.
'You also need my B4JDragToMe-library to run this demo.
'Note: 
'If you rename this project, you must remember to change the scenegrid.fxml layout
'file accordingly. Open the layout file with Notepad++ and change the following
'line: fx:controller="com.tillekesoft.B4JVlcj.main" with your project name.
'If you create your own fxml layout file, then it should not be needed.
'Read the notes in the code and the IDE-description for further information.
'*********************************************************************************************************** 

Sub Class_Globals
	Private fx As JFX
	Dim Videofrm As Form
	
	Private vlc As B4JVlcj
	Private Drag As B4JDragToMe
	Private btnStop As Button
	Private btnPause As Button
	Private btnMute As Button
	
	Private GridPane1 As Node
	Private BasePane As Pane
	
	Private btnPlay As Button
	Private btnMedia As Button
	Private VolSlider As Slider
	Private VolLevel As Int
	Private MediaFile As String
	Private lblDragHere As Label
	Private lblAltText As Label
	Private lblArrowDown As Label

	Dim Timer1 As Timer
	Private B4XSeekBar1 As B4XSeekBar
	
	Dim fullscreen As Boolean = False
	Private btnFullscreen As Button

End Sub

Public Sub Initialize
	
	
	
End Sub

'Add Local path or Url
'pass null
Sub start(path As String)
	'** IMPORTANT - checking if VLC is installed on the computer should be the first thing to execute in your code
	If vlc.IsVLCInstalled = False Then
		'Implement your own code to tell user that VLC must be installed.
		'Note: if VLC has been installed in a non-standard directory, VLC might not be found.
		Log("VLC must be installed on the computer to run this program.")
		Return
	End If
	
	Videofrm.Initialize("Videofrm", 500, 500)
	Videofrm.RootPane.LoadLayout("BaseFOrm")
	Videofrm.Resizable=True
	Videofrm.SetFormStyle("DECORATED")
	Videofrm.SetOwner(Main.MainForm)
	Videofrm.Title="Vlc Video Player..."
	Videofrm.Show
	


	Timer1.Initialize("Timer1", 1000)
	Timer1.Enabled = False


	'** OK, VLC was found. We can proceed.
	vlc.Initialize("vlc")


	
	'Now we load a fxml-layout so we can use a GridPane which is the control most suitable
	'for the video-output since it can easily be resized.
	BasePane.LoadLayout("scenegrid")
	SetBorderPaneBackgroundColor(GridPane1, "#000000")
	ShowDragButtons(True)
	
	'FullScreenMode
	
	
	AddVLCPlayerTo(GridPane1) ' adding VLC to the Gridpane
	Drag.Initialize(lblDragHere,"Drag") 'enabling drag and drop
	vlc.SetVolume(50)
	VolLevel = 50
	
	If path <> Null Then
		MediaFile = path
		StopAndPlayMedia
	End If


	
End Sub



Sub AddVLCPlayerTo (TheNode As Node)
	'we are using Javaobject here to expose a method of GridPane added
	'using a layout created with SceneBuilder. As the time of writing,
	'B4J does not include the GridPane control in its designer.
	Dim jo As JavaObject = TheNode
	jo.RunMethodJo("getChildren", Null).RunMethod("add", Array(vlc.player))
End Sub

Sub FullScreenMode
	
	Dim jmf As JavaObject = Videofrm
	Dim stage As JavaObject = jmf.GetField("stage")
	stage.RunMethod("setFullScreen", Array As Object(True))
	
'	'full screen
'	Videofrm.WindowWidth = fx.PrimaryScreen.MaxX - fx.PrimaryScreen.MinX
'	Videofrm.WindowLeft = fx.PrimaryScreen.MinX
'	Videofrm.WindowHeight = fx.PrimaryScreen.MaxY - fx.PrimaryScreen.MinY
'	Videofrm.WindowTop = fx.PrimaryScreen.MinY
'	
'	GridPane1.SetSize(Videofrm.Width,Videofrm.Height)
'	BasePane.SetSize(Videofrm.Width , Videofrm.Height)

End Sub

Sub SetBorderPaneBackgroundColor (TheNode As Node, colorhex As String)
	'we are using Javaobject here to expose a method of GridPane added
	'using a layout created with SceneBuilder. As the time of writing,
	'B4J does not include the GridPane control in its designer.
	Dim joBP As JavaObject = TheNode
	joBP.RunMethodJO("setStyle", Array("-fx-background-color: " & colorhex & ";"))
	'for colors values - see http://www.color-hex.com/
End Sub


Sub Videofrm_CloseRequest (EventData As Event)
	Log("We are closing the VideoPlayer")
	vlc.stop
	vlc.release
End Sub

Sub btnStop_Action
	If vlc.IsPlaying Then
		vlc.stop
		ShowDragButtons(True)
		MediaFile = ""
		Timer1.Enabled = False
		B4XSeekBar1.Value =0
	End If
End Sub

Sub btnPause_Action
	vlc.pause
	Timer1.Enabled = False
End Sub

Sub vlc_Prepared
	Log("Video is ready")
	
	GridPane1.SetSize(BasePane.Width,BasePane.Height)
	
	'set seekbar
	Log("Video Lenght = "&vlc.GetLength)
	B4XSeekBar1.MinValue = 0
	B4XSeekBar1.MaxValue = vlc.GetLength
	
	Timer1.Enabled = True
	
	
End Sub

Sub vlc_Finished
	Log("Video has finished or the format was not playable")
	ShowDragButtons(True)
End Sub

Sub vlc_Error
	Log("There was an error")
	ShowDragButtons(True)
End Sub

Sub btnMute_Action
	If vlc.GetVolume > 0 Then
		VolLevel = vlc.GetVolume
		btnMute.Text = ""
		vlc.Mute
		VolSlider.Value = 0
	Else
		btnMute.Text = ""
		vlc.Unmute(VolLevel)
		VolSlider.Value = vlc.GetVolume
	End If
	
End Sub


Sub Videofrm_Resize (Width As Double, Height As Double)
	GridPane1.SetSize(BasePane.PrefWidth,BasePane.PrefHeight)
	
	Log("Raise Resize...")
End Sub

Sub btnPlay_Action
	If MediaFile <> "" Or MediaFile.Length > 0 Then
		StopAndPlayMedia
	Else
		Log("no media file selected")
	End If
	
End Sub

Sub btnMedia_Action
	Dim mediapicker As FileChooser
	mediapicker.Initialize
	mediapicker.Title = "Choose a media to play"
	MediaFile = mediapicker.ShowOpen(Videofrm)
	If MediaFile <> "" Or MediaFile.Length > 0 Then
		StopAndPlayMedia
	End If
		
End Sub


Sub VolSlider_ValueChange (Value As Double)
	vlc.SetVolume(Value)
	If vlc.GetVolume = 0 Then
		btnMute.Text = ""
	Else
		btnMute.Text = ""
	End If
End Sub


Sub ShowDragButtons (enable As Boolean)
	'here we swap between video-view and drag&drop-view
	If enable Then
		GridPane1.Visible = False
		lblArrowDown.Visible = True
		lblDragHere.Visible = True
		lblAltText.Visible = True
	Else 'false
		GridPane1.Visible = True
		lblArrowDown.Visible = False
		lblDragHere.Visible = False
		lblAltText.Visible = False
	End If
End Sub

Sub Drag_ReceivedFilePath (Filepath As String)
	'Log(Filepath)
	MediaFile = Filepath
	If MediaFile <> "" Or MediaFile.Length > 0 Then
		StopAndPlayMedia
	End If
	
End Sub

Sub StopAndPlayMedia
	
	If vlc.IsPlaying Then
		vlc.Stop
	End If
	ShowDragButtons(False)
	vlc.Play(MediaFile)
'	vlc.Play("http://dl.nex1music.ir/1399/11/25/Hamed%20Tari%20&%20Ali%20Khazaeli%20-%20Nisti%20Mesle%20Sabegh%20%5BNex1Music.IR%5D%20%5B480%5D.mp4")

	vlc.SetVolume(50)
	VolLevel = 50
	

End Sub

#IgnoreWarnings : 12
Sub GetFps As Float
	
	'** This is an example how you can use the JavaObject with the B4JVlcj-wrapper
	'** to expose other methods/fields of the Player-object:
	'** In this case, we call a method to get the number of frames-per-second the video is playing (Fps).
	'** API desciption from Vlcj JavaDocs for getFps() is:
	'/**
	'* Get the current play-back frames-per-second.
	' * Returns: number of frames-per-second
	' */
	'**
	
	Dim jo As JavaObject = vlc.player
	Dim fps As Float
	fps = jo.RunMethodJo("getMp", Null).RunMethod("getFps",Null)
	Return fps
	
	
End Sub

'Sub btnGetFps_Action
'
''	If vlc.IsPlaying Then
''		Log("Fps value is: " & GetFps)
''	End If
'	
'	
'End Sub




Sub Timer1_Tick
	
	 B4XSeekBar1.Value = vlc.GetTime
End Sub



Private Sub B4XSeekBar1_ValueChanged (Value As Int)

	vlc.SetTime(Value)
End Sub

Private Sub B4XSeekBar1_TouchStateChanged (Pressed As Boolean)
	Log(Pressed)
End Sub

Private Sub btnFullscreen_Click
	
	If fullscreen Then
		 
		 Videofrm.WindowHeight = 500
		 Videofrm.WindowWidth = 500
		 fullscreen  =False
	     btnFullscreen.Text = Chr(0xE5D0)
		
		Dim jmf As JavaObject = Videofrm
		Dim stage As JavaObject = jmf.GetField("stage")
		stage.RunMethod("setFullScreen", Array As Object(False))
'		 GridPane1.SetSize(Videofrm.Width,Videofrm.Height)
		fullscreen  =False
	Else
		
'		FullScreenMode
		Dim jmf As JavaObject = Videofrm
		Dim stage As JavaObject = jmf.GetField("stage")
		stage.RunMethod("setFullScreen", Array As Object(True))
	    fullscreen  =True
	    btnFullscreen.Text = Chr(0xE5D1)	
			
	End If
	
	
	
End Sub